<?php
// feed version diaRice 0.3 en/de (c) Michael Daum, 2007 
// visit http://webdaum.de/ 

header('Content-Type: application/xml');

define("_PATH",realpath("./"));
include_once ("classes/calendar.inc.php");
include_once ("classes/login.inc.php");
include_once ("classes/profile.inc.php");
$p = new profile();
$p->load_data();

if(!isset($_GET['lang'])) {
	$_GET['lang'] = "en";
}
if(!isset($_GET['version'])) {
	$_GET['version'] = "rss2";
}

$c = new calendar();
$max = $c->c_max_period;
$resources = "";
$items = "";


	
if(strtolower(CHARSET)=="utf-8") {
	$c->c_my_name = utf8_encode( $c->c_my_name);
}

// build array that contains all calendar days:
$c_month_length = Array(31,28,31,30,31,30,31,31,30,31,30,31);	
$i=0;

for($c_year = $c->c_first_year; $c_year<=$c->c_year; $c_year++) {
	
			
	if(checkdate(2,29,$c_year)) {
		$c_month_length[1]+=1;
	}
	
	$c_month=$c_year==$c->c_first_year?$c->c_first_month:0;
	
  for ($c_month;$c_month<12; $c_month++) {
  
  	$c_day=$c_year==$c->c_first_year&&$c_month==$c->c_first_month?$c->c_first_day:1;
  	
  	for ($c_day; $c_day<=$c_month_length[$c_month]; $c_day++) {
  	
  		$C[$i] = new calendar($c_year,$c_month,$c_day);
      
			if($C[$i]->c_timestamp > C_TODAYS_DATE) {
  			unset($C[$i]);
				break;
			} else if(!is_file($C[$i]->c_image_resource)) {
  			unset($C[$i]);
			}
			
  		$C[$i]->c_my_email = $p->data[$C[$i]->c_author[$c_day]]->email;
  		$C[$i]->c_my_name = $p->data[$C[$i]->c_author[$c_day]]->fullname;
  			
      if(strtolower(CHARSET)=="utf-8") {
      	$C[$i]->c_my_name = utf8_encode( $C[$i]->c_my_name );
      }
      
			$i++;
  	}
  	
  }
}

$C = array_reverse($C);

echo '<?xml version="1.0" encoding="'.$c->c_charset.'"?'.">\n";
echo'<?xml-stylesheet href="css/feed.css" type="text/css"?'.">\n";
if($_GET['version']=="atom") {
echo '<feed xmlns="http://www.w3.org/2005/Atom">
  <title>'.$c->c_calendar_name.' '.$c->c_my_name.'</title>
  <link href="'.$c->c_host.'/" />
  <author>
    <name>'.$c->c_my_name.'</name>
  </author>
  <updated>'.$c->c_updated.'</updated>
  <id>'."tag:".$_SERVER['HTTP_HOST'].",".$c->c_first_year.":diaRice/".$c->c_lang.'</id>
  <link rel="self" href="'.$c->c_host.$_SERVER['PHP_SELF'].'?version=atom&amp;lang='.$c->c_lang.'"/>
';
  for ($i=0; $i<$max; $i++) {

	echo '
  <entry>
    <title>'.$C[$i]->print_day().'</title>
    <link href="'.$C[$i]->c_abs_path($c->c_lang).'"/>
    <id>'.$C[$i]->c_uid.'</id>
    <author>
      <name>'.$C[$i]->c_my_name.'</name>
    </author>
    <updated>'.$C[$i]->c_updated.'</updated>
    <summary>'.$c->c_calendar_name.' '.$C[$i]->print_day().'</summary>
  </entry>';
  }
echo '</feed>';

} else if($_GET['version']=="rss1") {

	// RSS 1.0:
  echo'<rdf:RDF 
xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" 
xmlns="http://purl.org/rss/1.0/">
<channel rdf:about="'.$c->c_host.$_SERVER['PHP_SELF'].'">
<title>'.$c->c_calendar_name.' '.$c->c_my_name.'</title>
<description>'.$c->c_my_name." ".$c->c_tooltipp['about'].'</description>
<link>'.$c->c_host.'/</link>
<image rdf:resource="'.$c->c_host.dirname($PHP_SELF)."/css/templates/diaRice_feed.png".'" />
<items>
<rdf:Seq>';

  for ($i=0; $i<$max; $i++) {
  	$resources.= '<rdf:li resource="'.$C[$i]->c_abs_path.'" />
';
  	$items.= '<item rdf:about="'.$C[$i]->c_abs_path.'">
<title>'.$C[$i]->print_day().'</title>
<description>'.$c->c_calendar_name.' '.$C[$i]->print_day().'</description>
  ';
  $items.='<link>'.$C[$i]->c_abs_path($c->c_lang).'</link>
</item>
  ';
  }
  
  echo $resources;
  echo'</rdf:Seq>
</items>
</channel>
<image rdf:about="'.$c->c_host.dirname($PHP_SELF)."/css/templates/diaRice_feed.png".'">
<title>'.$c->c_calendar_name.'</title>
<link>'.$c->c_host.'/</link>
<url>'.$c->c_host.dirname($PHP_SELF)."/css/templates/diaRice_feed.png".'</url>
</image>';
  echo $items;
  echo '</rdf:RDF>';
  
} else {
	
	// RSS 2.0:
	echo '<rss version="2.0">
<channel>
<title>'.$c->c_calendar_name.' '.$c->c_my_name.'</title>
<link>'.$c->c_host.'/</link>
<description>'.$c->c_my_name." ".$c->c_tooltipp['about'].'</description>
<language>'.$_GET['lang'].'-'.$_GET['lang'].'</language>
<copyright>copyright '.$c->c_todays_date['year'].', '.
$c->c_my_name.'</copyright>
<pubDate>'.$c->c_rfc_822.'</pubDate>
<image>
<url>'.$c->c_host.dirname($PHP_SELF)."/css/templates/diaRice_feed.png".'</url>
<title>'.$c->c_calendar_name.'</title>
<link>'.$c->c_host.'/</link>
</image>
';

  for ($i=0; $i<$max; $i++) {

	echo '
<item>
<title>'.$C[$i]->print_day().'</title>
<description>'.$c->c_calendar_name.' '.$C[$i]->print_day().'</description>
<author>'.$C[$i]->c_my_name.' &lt;'.$C[$i]->c_my_email.'&gt;</author>
<guid isPermaLink="false">'.$C[$i]->c_uid.'</guid>
<link>'.$C[$i]->c_abs_path($c->c_lang).'</link>
</item>
';
  }
    
echo '</channel>
</rss>';
}
?>